// DSWFilesDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "mkdocwrt.h"
#include "DSWFilesDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDSWFilesDlg 


CDSWFilesDlg::CDSWFilesDlg(CWnd* pParent, CStringList *pFileList)
	: CDialog(CDSWFilesDlg::IDD, pParent), m_pFileList(pFileList)
{
	//{{AFX_DATA_INIT(CDSWFilesDlg)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
}


void CDSWFilesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDSWFilesDlg)
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_LIST_DSWFILES, m_lstDswFiles);
}


BEGIN_MESSAGE_MAP(CDSWFilesDlg, CDialog)
	//{{AFX_MSG_MAP(CDSWFilesDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDSWFilesDlg 

BOOL CDSWFilesDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	ASSERT(m_pFileList);
	ASSERT(!m_pFileList->IsEmpty());
    POSITION pos = NULL;
    for (pos = m_pFileList->GetHeadPosition();pos;)
    {
        POSITION oldPos = pos;
	    CString strFile = m_pFileList->GetNext(pos);
        int iLastBackslash = strFile.ReverseFind(_T('\\'));
        if(-1!=iLastBackslash)
        {
            int iIndex = m_lstDswFiles.AddString(strFile.Mid(iLastBackslash+1));
            if(iIndex>=0)
            {
                DWORD dwAtt = GetFileAttributes(strFile);
                ASSERT(INVALID_FILE_ATTRIBUTES!=dwAtt);
                m_lstDswFiles.SetCheck(iIndex, dwAtt&FILE_ATTRIBUTE_READONLY ? 1:0);
                VERIFY(LB_ERR!=m_lstDswFiles.SetItemDataPtr(iIndex, oldPos));
            }
        }

        
    }
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CDSWFilesDlg::OnOK() 
{
    int iCount = m_lstDswFiles.GetCount();
    if (LB_ERR!=iCount)
    {
        while (iCount)
        {
            iCount--;
            
            if(m_lstDswFiles.GetCheck(iCount)!=0)
            {
                POSITION pos = (POSITION)m_lstDswFiles.GetItemDataPtr(iCount);
                ASSERT(pos);
                m_pFileList->RemoveAt(pos);
            }
        }
    }
	
	CDialog::OnOK();
}
